// unit contenant des fonctions de traitements de chaine
unit type_string_delphi;

interface

uses
{$IFDEF VERSIONS}
  fonctions_version,
{$ENDIF}
  Classes;

const
{$IFDEF VERSIONS}
    gVer_type_string : T_Version = ( Component : 'Ressources chanes' ; FileUnit : 'fonctions_string' ;
                        	     Owner : 'Matthieu Giroux' ;
                        	     Comment : 'String types.' ;
                        	     BugsStory :'Version 1.0.0.0 : Creating structure for delphi.';
                        	     UnitType : 1 ;
                        	     Major : 1 ; Minor : 0 ; Release : 0 ; Build :  0);
{$ENDIF}
    CST_ORD_GUILLEMENT = ord ( '''' );
    CST_ORD_POURCENT   = ord ( '%' );
    CST_ORD_ASTERISC   = ord ( CST_SQL_ALL );
    CST_ORD_SOULIGNE   = ord ( '_' );
    CST_ORD_OUVRECROCHET   = ord ( '[' );
    CST_ORD_FERMECROCHET   = ord ( ']' );

type
  TCharToUTF8Table = array[Ansichar] of PChar;

const  SansAccents : TCharToUTF8Table
             = (#0,#1,#2,#3,#4,#5,#6,#7,#8,#9,#10,#11,#12,#13,#14,#15,#16,#17,#18,#19,#20,#21,#22,#23,#24,#25,#26,#27,#28,#29,#30,#31,#32,#33,#34,#35,#36,#37,#38,#39,#40,#41,#42,#43,#44,#45,#46,#47,#48,#49,#50,#51,#52,#53,#54,#55,#56,#57,#58,#59,#60,#61,#62,#63,#64,
                'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',#91,#92,#93,#94,#95,#96,
                'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z',#123,#124,#125,#126,#127,
                'A','A','A','A','A','A','A','C','E','E','E','E','I','I','I','I','D','N','O','O','O','O','O','','O','U','U','U','U','Y','D','B',
                'a','a','a','a','a','a','a','c','e','e','e','e','i','i','i','i','o','n','o','o','o','o','o','','o','u','u','u','u','y','d','y',
                #192,#193,#194,#195,#196,#197,#198,#199,#200,#201,#202,#203,#204,#205,#206,#207,#208,#209,#210,#211,#212,#213,#214,#215,#216,#217,#218,#219,#220,#221,#222,#223,#224,#225,#226,#227,#228,#229,#230,#231,#232,#233,#234,#235,#236,#237,#238,#239,#240,#241,#242,#243,#244,#245,#246,#247,#248,#249,#250,#251,#252,#253,#254,#255);
      Minuscules : TCharToUTF8Table
      = (#0,#1,#2,#3,#4,#5,#6,#7,#8,#9,#10,#11,#12,#13,#14,#15,#16,#17,#18,#19,#20,#21,#22,#23,#24,#25,#26,#27,#28,#29,#30,#31,#32,#33,#34,#35,#36,#37,#38,#39,#40,#41,#42,#43,#44,#45,#46,#47,#48,#49,#50,#51,#52,#53,#54,#55,#56,#57,#58,#59,#60,#61,#62,#63,#64,
         'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z',#91,#92,#93,#94,#95,#96,
         'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z',#123,#124,#125,#126,#127,
                   '','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','d','b',
                   '','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','d','',
                   #192,#193,#194,#195,#196,#197,#198,#199,#200,#201,#202,#203,#204,#205,#206,#207,#208,#209,#210,#211,#212,#213,#214,#215,#216,#217,#218,#219,#220,#221,#222,#223,#224,#225,#226,#227,#228,#229,#230,#231,#232,#233,#234,#235,#236,#237,#238,#239,#240,#241,#242,#243,#244,#245,#246,#247,#248,#249,#250,#251,#252,#253,#254,#255);
      Majuscules :TCharToUTF8Table
      = (#0,#1,#2,#3,#4,#5,#6,#7,#8,#9,#10,#11,#12,#13,#14,#15,#16,#17,#18,#19,#20,#21,#22,#23,#24,#25,#26,#27,#28,#29,#30,#31,#32,#33,#34,#35,#36,#37,#38,#39,#40,#41,#42,#43,#44,#45,#46,#47,#48,#49,#50,#51,#52,#53,#54,#55,#56,#57,#58,#59,#60,#61,#62,#63,#64,
         'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',#91,#92,#93,#94,#95,#96,
        'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',#123,#124,#125,#126,#127,
               '','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','D','B',
               '','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','D','Y',
      #192,#193,#194,#195,#196,#197,#198,#199,#200,#201,#202,#203,#204,#205,#206,#207,#208,#209,#210,#211,#212,#213,#214,#215,#216,#217,#218,#219,#220,#221,#222,#223,#224,#225,#226,#227,#228,#229,#230,#231,#232,#233,#234,#235,#236,#237,#238,#239,#240,#241,#242,#243,#244,#245,#246,#247,#248,#249,#250,#251,#252,#253,#254,#255);

implementation

{$IFDEF VERSIONS}
initialization
  p_ConcatVersion ( gVer_type_string );
{$ENDIF}
end.     